HDU 1011 Starship Troopers(树形DP+01背包)

Description
You, the leader of Starship Troopers, are sent to destroy a base of the bugs. The base is built underground. It is actually a huge cavern, which consists of many rooms connected with tunnels. Each room is occupied by some bugs, and their brains hide in some of the rooms. Scientists have just developed a new weapon and want to experiment it on some brains. Your task is to destroy the whole base, and capture as many brains as possible.

To kill all the bugs is always easier than to capture their brains. A map is drawn for you, with all the rooms marked by the amount of bugs inside, and the possibility of containing a brain. The cavern's structure is like a tree in such a way that there is one unique path leading to each room from the entrance. To finish the battle as soon as possible, you do not want to wait for the troopers to clear a room before advancing to the next one, instead you have to leave some troopers at each room passed to fight all the bugs inside. The troopers never re-enter a room where they have visited before.

A starship trooper can fight against 20 bugs. Since you do not have enough troopers, you can only take some of the rooms and let the nerve gas do the rest of the job. At the mean time, you should maximize the possibility of capturing a brain. To simplify the problem, just maximize the sum of all the possibilities of containing brains for the taken rooms. Making such a plan is a difficult job. You need the help of a computer.


Input
The input contains several test cases. The first line of each test case contains two integers N (0 < N <= 100) and M (0 <= M <= 100), which are the number of rooms in the cavern and the number of starship troopers you have, respectively. The following N lines give the description of the rooms. Each line contains two non-negative integers -- the amount of bugs inside and the possibility of containing a brain, respectively. The next N - 1 lines give the description of tunnels. Each tunnel is described by two integers, which are the indices of the two rooms it connects. Rooms are numbered from 1 and room 1 is the entrance to the cavern.

The last test case is followed by two -1's.


Output

For each test case, print on a single line the maximum sum of all the possibilities of containing brains for the taken rooms.


Sample Input
5 10
50 10
40 10
40 20
65 30
70 30
1 2
1 3
2 4
2 5
1 1
20 7

-1 -1


Sample Output
50

7


题意:有N个洞穴,M个士兵。N-1个联通的情况。从1号洞穴出发,每个士兵可以消灭20个bug,只要消灭了当前洞穴的所有bug才获得对应的价值hi,并进入与之相连的其他洞穴。比如,1与2,3相连,可以派一部分士兵进入2,一部分进入3。求获得的最大价值。


思路:设dp[i][j]表示当前i号洞穴有j个士兵时最大可获得的价值。对于每个洞穴,相当于一个01背包问题,与之相连的洞穴就相当于物品,选择是否进入洞穴,来获得最大价值。

dp[i][j]=max(dp[i][j],dp[i][j-k]+dp[son[i]][k]);k表示从j个士兵中派k个士兵进入son[i]洞穴。然后从1号洞穴开始dfs就好了。


几个要注意的地方:

1.当M=0时,直接输出0。(但是要在数据全部输入进来以后再输出0啊!)

2.洞穴之前应该是双向的。

3.即使该洞穴有0个bug,也至少要派一个士兵经过他。

5 2

0 1 0 1 0 5 0 1 0 2 1 2 1 3 2 4 2 5

输出9

4.由于相当于对每个洞穴都求一次01背包,所以这个背包相当于一维的,枚举容量时需要从大到小。


#include <iostream>
#include <stdio.h>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <cstdlib>
#include <string.h>
#include <vector>
#include <queue>
#include <stack>
#include <ctype.h>
using namespace std;

int n,m;

struct node
{
    int s,h;
}a[105];

vector<int> v[105];

int dp[105][105];
int vis[105];

void dfs(int f)
{
    vis[f]=1;
    int temp=(a[f].s+19)/20;
    for(int j=temp;j<=m;j++)
    {
        dp[f][j]=a[f].h;
    }
    for(int i=0;i<v[f].size();i++)
    {
        if(vis[v[f][i]]==1) continue;
        dfs(v[f][i]);
        for(int j=m;j>=temp;j--)
        {
            for(int k=1;k<=j-temp;k++)
            {
                dp[f][j]=max(dp[f][j],dp[f][j-k]+dp[v[f][i]][k]);
            }
        }
    }
}

int main()
{
    while(scanf("%d%d",&n,&m)!=EOF)
    {
        if(n==m&&n==-1) break;
        for(int i=1;i<=n;i++)
        {
            scanf("%d%d",&a[i].s,&a[i].h);
        }
        for(int i=0;i<=n;i++)
        {
            v[i].clear();
        }
        for(int i=1;i<n;i++)
        {
            int fa,son;
            scanf("%d%d",&fa,&son);
            v[fa].push_back(son);
            v[son].push_back(fa);
        }
        if(m==0)
        {
            cout<<"0"<<endl;
            continue;
        }
        memset(vis,0,sizeof(vis));
        memset(dp,0,sizeof(dp));
        dfs(1);
        cout<<dp[1][m]<<endl;
    }
    return 0;
}



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值